##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

#====LEVEL 1=====
#Colors
$(eval $(call ADD2PACK,level1_pack,src/bin/colours_0_25.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/colours_0_50.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/colours_0_75.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/colours_0_100.bin))
#Enemy
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1Left.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1Right.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1Down.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1LeftAlert.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1RightAlert.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1DownLeft.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1DownRight.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1Up.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1UpRight.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemy1UpLeft.bin))
#Obstacles
$(eval $(call ADD2PACK,level1_pack,src/bin/ForestSmall.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/ForestMiddle.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/ForestBig.bin))
#Enemy shooter
$(eval $(call ADD2PACK,level1_pack,src/bin/enemyShooterRightGreen.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/enemyShooterLeftGreen.bin))
#GUI
$(eval $(call ADD2PACK,level1_pack,src/bin/gui_wood.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/level_1-1_label.bin))
$(eval $(call ADD2PACK,level1_pack,src/bin/niveldos.bin))


$(eval $(call PACKZX7B,level1_pack,src/compressedPacks/))


#====LEVEL 2=====
#Colours
$(eval $(call ADD2PACK,level2_pack,src/bin/colours_1_25.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/colours_1_50.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/colours_1_75.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/colours_1_100.bin))
#Enemy
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1LeftGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1RightGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1DownGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1LeftAlertGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1RightAlertGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1DownLeftGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1DownRightGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1UpAlertGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1UpRightGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemy1UpLeftGreen.bin))
#Obstacles
$(eval $(call ADD2PACK,level2_pack,src/bin/BeachSmall.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/BeachMiddle.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/BeachBig.bin))
#Enemy shooter
$(eval $(call ADD2PACK,level2_pack,src/bin/enemyShooterRightGreen.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/enemyShooterLeftGreen.bin))
#GUI
$(eval $(call ADD2PACK,level2_pack,src/bin/gui_beach.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/level_2-1_label.bin))
$(eval $(call ADD2PACK,level2_pack,src/bin/level_2-2_label.bin))


$(eval $(call PACKZX7B,level2_pack,src/compressedPacks/))

#====LEVEL 3=====
#Colours
$(eval $(call ADD2PACK,level3_pack,src/bin/colours_2_25.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/colours_2_50.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/colours_2_75.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/colours_2_100.bin))
#Enemy
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1LeftBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1RightBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1DownBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1LeftAlertBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1RightAlertBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1DownLeftBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1DownRightBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1UpAlertBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1UpRightBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemy1UpLeftBlue.bin))
#Obstacles
$(eval $(call ADD2PACK,level3_pack,src/bin/MilitarySmall.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/MilitaryMiddle.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/MilitaryBig.bin))
#Enemy shooter
$(eval $(call ADD2PACK,level3_pack,src/bin/enemyShooterRightBlue.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/enemyShooterLeftBlue.bin))
#GUI
$(eval $(call ADD2PACK,level3_pack,src/bin/militaryBase.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/level_3-1_label.bin))
$(eval $(call ADD2PACK,level3_pack,src/bin/level_3-2_label.bin))


$(eval $(call PACKZX7B,level3_pack,src/compressedPacks/))


#====LEVEL 4=====
#Colours
$(eval $(call ADD2PACK,level4_pack,src/bin/colours_2_100.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/colours_2_100.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/colours_2_100.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/colours_2_100.bin))
#Enemy
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1LeftWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1RightWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1DownWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1LeftAlertWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1RightAlertWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1DownLeftWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1DownRightWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1UpWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1UpRightWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemy1UpLeftWhite.bin))
#Obstacles
$(eval $(call ADD2PACK,level4_pack,src/bin/RoadSmall.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/RoadMiddle.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/RoadBig.bin))
#Enemy shooter
$(eval $(call ADD2PACK,level4_pack,src/bin/enemyShooterRightWhite.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/enemyShooterLeftWhite.bin))
#GUI
$(eval $(call ADD2PACK,level4_pack,src/bin/gui_road.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/level_4-1_label.bin))
$(eval $(call ADD2PACK,level4_pack,src/bin/level_4-1_label.bin))


$(eval $(call PACKZX7B,level4_pack,src/compressedPacks/))


#=====DEADSCREEN====

$(eval $(call ADD2PACK,deadScreen_pack,src/bin/gameOver.bin))
$(eval $(call ADD2PACK,deadScreen_pack,src/bin/bnw.bin))
$(eval $(call ADD2PACK,deadScreen_pack,src/bin/pressToTryAgain.bin))


$(eval $(call PACKZX7B,deadScreen_pack,src/compressedPacks/))

#====WINSCREEN=======
$(eval $(call ADD2PACK,winScreen_pack,src/bin/winner.bin))
$(eval $(call ADD2PACK,winScreen_pack,src/bin/recovered.bin))
$(eval $(call ADD2PACK,winScreen_pack,src/bin/pressToTryAgain.bin))

$(eval $(call PACKZX7B,winScreen_pack,src/compressedPacks/))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################