##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
#PALETTE=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtimles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

PALETTE=13 0 6 26 3 16 13 11 20 2 1 25 18 24 19 9
$(eval $(call IMG2SP, SET_PALETTE_FW, $(PALETTE)         ))
$(eval $(call IMG2SP, SET_IMG_FORMAT, sprites            ))
$(eval $(call IMG2SP, SET_OUTPUT      , c                ))  
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites               ))



#Menu
#$(eval $(call IMG2SP, CONVERT, assets/logaso.png , 64, 64, menu_logo1, ))
#$(eval $(call IMG2SP, CONVERT, assets/logaso2.png , 64, 64, menu_logo2, ))



#POWERUP
$(eval $(call IMG2SP, CONVERT, assets/powerUp_sprite.png , 8, 16, pu_sprite, ))

#GUI
$(eval $(call IMG2SP, CONVERT, assets/pressToPlay.png , 86, 8, menu_pressToPlay, palette))
$(eval $(call IMG2SP, CONVERT, assets/gui_top_data.png , 32, 72, gui_top_data, ))
$(eval $(call IMG2SP, CONVERT, assets/player_life.png , 8, 16, player_life, ))
$(eval $(call IMG2SP, CONVERT, assets/gui_arrow.png , 16, 16, gui_arrow, ))
$(eval $(call IMG2SP, CONVERT, assets/gui_arrow2.png , 16, 16, gui_arrow2, ))


#Colour 0
$(eval $(call IMG2SP, CONVERT, assets/colours_0.png , 32, 32, colours_0, ))

#======PLAYER======
$(eval $(call IMG2SP, CONVERT, assets/playerLeft.png , 8, 16, playerLeft,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerRight.png , 8, 16, playerRight,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerUp.png , 8, 16, playerUp,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerDown.png , 8, 16, playerDown,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerUpRight.png , 8, 16, playerUpRight,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerUpLeft.png , 8, 16, playerUpLeft,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerDownRight.png , 8, 16, playerDownRight,, ))
$(eval $(call IMG2SP, CONVERT, assets/playerDownLeft.png , 8, 16, playerDownLeft,, ))

#=======ASSASSIN OBSTACLE=====
$(eval $(call IMG2SP, CONVERT, assets/assassinObstacle2.png , 32, 32, assassinObstacle,, ))

#=======BULLETS========
$(eval $(call IMG2SP, CONVERT, assets/bulletSprite.png , 2, 4, bulletSprite,, ))
$(eval $(call IMG2SP, CONVERT, assets/laserSprite.png , 4, 8, laserSprite,, ))


#==============================================COMPRESSED========================================================================
$(eval $(call IMG2SP, SET_OUTPUT      , bin                )) 
$(eval $(call IMG2SP, SET_FOLDER      , src/bin             ))


#======LEVEL 1========
#Red enemy
$(eval $(call IMG2SP, CONVERT, assets/enemy1Left.png , 8, 16, enemyLeft,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1Right.png , 8, 16, enemyRight,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1Down.png , 8, 16, enemyDown,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftAlert.png , 8, 16, enemyLeftAlert,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightAlert.png , 8, 16, enemyRightAlert,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownLeft.png , 8, 16, enemyDownLeft,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownRight.png , 8, 16, enemyDownRight, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1Up.png , 8, 16, enemyUp, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpRight.png , 8, 16, enemyUpRight, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpLeft.png , 8, 16, enemyUpLeft, ))

#Forest
$(eval $(call IMG2SP, CONVERT, assets/ForestSmall.png , 16, 32, ForestSmall,, ))
$(eval $(call IMG2SP, CONVERT, assets/ForestMiddle.png , 32, 32, ForestMiddle,, ))
$(eval $(call IMG2SP, CONVERT, assets/ForestBig.png, 64, 32, ForestBig,, ))

#GUI
$(eval $(call IMG2SP, CONVERT, assets/gui_wood.png , 32, 64, gui_wood_display, ))
$(eval $(call IMG2SP, CONVERT, assets/level_1-1_label.png , 32, 32, gui_11_label, ))
$(eval $(call IMG2SP, CONVERT, assets/niveldos.png , 32, 32, gui_12_label, ))



#======LEVEL 2========
#Green
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftGreen.png , 8, 16, enemyLeftGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightGreen.png , 8, 16, enemyRightGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownGreen.png , 8, 16, enemyDownGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftAlertGreen.png , 8, 16, enemyLeftAlertGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightAlertGreen.png , 8, 16, enemyRightAlertGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownLeftGreen.png , 8, 16, enemyDownLeftGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownRightGreen.png , 8, 16, enemyDownRightGreen, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpAlertGreen.png , 8, 16, enemyUpGreen, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpRightGreen.png , 8, 16, enemyUpRightGreen, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpLeftGreen.png , 8, 16, enemyUpLeftGreen, ))

#Beach
$(eval $(call IMG2SP, CONVERT, assets/BeachSmall.png , 16, 32, BeachSmall,, ))
$(eval $(call IMG2SP, CONVERT, assets/BeachMiddle.png , 32, 32, BeachMiddle,, ))
$(eval $(call IMG2SP, CONVERT, assets/BeachBig.png, 64, 32, BeachBig,, ))

#Shooter enemy
$(eval $(call IMG2SP, CONVERT, assets/enemyShooterRightGreen.png , 8, 16, enemyShooterRightGreen,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemyShooterLeftGreen.png , 8, 16, enemyShooterLeftGreen,, ))

#GUI
$(eval $(call IMG2SP, CONVERT, assets/gui_beach.png , 32, 64, gui_beach_display, ))
$(eval $(call IMG2SP, CONVERT, assets/level_2-1_label.png , 32, 32, level_21_label, ))
$(eval $(call IMG2SP, CONVERT, assets/level_2-2_label.png , 32, 32, level_22_label, ))




#======LEVEL 3========
#Blue enemy
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftBlue.png , 8, 16, enemyLeftBlue,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightBlue.png , 8, 16, enemyRightBlue,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownBlue.png , 8, 16, enemyDownBlue,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftAlertBlue.png , 8, 16, enemyLeftBlueAlert,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightAlertBlue.png , 8, 16, enemyRightBlueAlert,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownLeftBlue.png , 8, 16, enemyDownLeftBlue,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownRightBlue.png , 8, 16, enemyDownRightBlue, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpAlertBlue.png , 8, 16, enemyUpBlue, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpRightBlue.png , 8, 16, enemyUpRightBlue, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpLeftBlue.png , 8, 16, enemyUpLeftBlue, ))

#Military 
$(eval $(call IMG2SP, CONVERT, assets/MilitarySmall.png , 16, 32, MilitarySmall,, ))
$(eval $(call IMG2SP, CONVERT, assets/MilitaryMiddle.png , 32, 32, MilitaryMiddle,, ))
$(eval $(call IMG2SP, CONVERT, assets/MilitaryBig.png, 64, 32, MilitaryBig,, ))

#Shooter enemy
$(eval $(call IMG2SP, CONVERT, assets/enemyShooterRightBlue.png , 8, 16, enemyShooterRightBlue,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemyShooterLeftBlue.png , 8, 16, enemyShooterLeftBlue,, ))

#GUI
$(eval $(call IMG2SP, CONVERT, assets/militaryBase.png , 32, 64, gui_military_display, ))
$(eval $(call IMG2SP, CONVERT, assets/level_3-1_label.png , 32, 32, level_31_label, ))
$(eval $(call IMG2SP, CONVERT, assets/level_3-2_label.png , 32, 32, level_32_label, ))



#======LEVEL 4========
#White enemy
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftWhite.png , 8, 16, enemyLeftWhite,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightWhite.png , 8, 16, enemyRightWhite,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownWhite.png , 8, 16, enemyDownWhite,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1LeftAlertWhite.png , 8, 16, enemyLeftWhiteAlert,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1RightAlertWhite.png , 8, 16, enemyRightWhiteAlert,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownLeftWhite.png , 8, 16, enemyDownLeftWhite,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1DownRightWhite.png , 8, 16, enemyDownRightWhite, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpWhite.png , 8, 16, enemyUpWhite, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpRightWhite.png , 8, 16, enemyUpRightWhite, ))
$(eval $(call IMG2SP, CONVERT, assets/enemy1UpLeftWhite.png , 8, 16, enemyUpLeftWhite, ))

#Road
$(eval $(call IMG2SP, CONVERT, assets/RoadSmall.png , 16, 32, RoadSmall,, ))
$(eval $(call IMG2SP, CONVERT, assets/RoadMiddle.png , 32, 32, RoadMiddle,, ))
$(eval $(call IMG2SP, CONVERT, assets/RoadBig.png , 64, 32, RoadBig,, ))

#Shooter enemy
$(eval $(call IMG2SP, CONVERT, assets/enemyShooterRightWhite.png , 8, 16, enemyShooterRightWhite,, ))
$(eval $(call IMG2SP, CONVERT, assets/enemyShooterLeftWhite.png , 8, 16, enemyShooterLeftWhite,, ))

#GUI
$(eval $(call IMG2SP, CONVERT, assets/gui_road.png , 32, 64, gui_road_display, ))
$(eval $(call IMG2SP, CONVERT, assets/level_4-1_label.png , 32, 32, gui_41_label, ))


#=============DeadScreen=====================
$(eval $(call IMG2SP, CONVERT, assets/gameOver.png , 52, 8, ds_gameOver, ))
$(eval $(call IMG2SP, CONVERT, assets/bnw.png , 76, 8, ds_bnw, ))
$(eval $(call IMG2SP, CONVERT, assets/pressToTryAgain.png , 126, 8, ds_pressToTryAgain, ))

#Colour percentage
#Red
$(eval $(call IMG2SP, CONVERT, assets/colours_0_25.png , 32, 32, colours_0_25, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_0_50.png , 32, 32, colours_0_50, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_0_75.png , 32, 32, colours_0_75, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_0_100.png , 32, 32, colours_0_100, ))

#Green
$(eval $(call IMG2SP, CONVERT, assets/colours_1_25.png , 32, 32,  colours_1_25, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_1_50.png , 32, 32,  colours_1_50, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_1_75.png , 32, 32,  colours_1_75, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_1_100.png , 32, 32, colours_1_100, ))

#Blue
$(eval $(call IMG2SP, CONVERT, assets/colours_2_25.png , 32, 32,  colours_2_25, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_2_50.png , 32, 32,  colours_2_50, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_2_75.png , 32, 32,  colours_2_75, ))
$(eval $(call IMG2SP, CONVERT, assets/colours_2_100.png , 32, 32, colours_2_100, ))

#=============WinScreen==========================
$(eval $(call IMG2SP, CONVERT, assets/winner.png , 40, 8, winner_Winner, ))
$(eval $(call IMG2SP, CONVERT, assets/recovered.png , 82, 8, winner_recovered, ))



##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
