;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.globl bullet_New
.globl bullet_Copy
.globl bullet_DoForAll
.globl bullet_CheckLFT
.globl bullet_GetNumBullet
.globl bullet_GetBulletsSize
.globl bullet_Destroy
.globl bullet_GetVelocity
.globl bullet_CheckScreenCollissions
.globl bullet_Collissions
.globl bullet_DestroyEveryBullet
.globl bullet_ActivatePU
.globl bullet_Move

.globl bullet_data

.macro DefineBullet _name, _x, _y, _vx, _vy, _w, _h, _sprite, _frontX, _frontY, _backX, _backY, _upd, _lft, _dead, _damage
_name: 
    DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sprite, _frontX, _frontY, _backX, _backY
   .db   _vx, _vy    ;; VX, VY
   .dw   _upd        ;; Update 
   .db   _lft        ;; Lifetime
   .db   _dead       ;; Dead
   .db   _damage
_name'_size = . - _name
.endm

.macro DefineBulletDefault _name, _suf                      
    DefineBullet _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0xFFFF, 0, 0, 0, 0, 0xFFFF, 0, 1, 0
.endm

.macro DefineNBullets _name, _n
    _c = 0
    .rept _n
        DefineBulletDefault _name, \_c
        _c = _c + 1
    .endm
.endm

b_de       = 0
b_de_size  = 10                 ;;Size of the Drawable entity, by now we have to count the size of the DE
b_vx       = 0 + b_de_size     ;;New offsets 
b_vy       = 1 + b_de_size
b_up_l     = 2 + b_de_size
b_up_h     = 3 + b_de_size
b_lft      = 4 + b_de_size
b_dead     = 5 + b_de_size
b_damage   = 6 + b_de_size

