;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.include "deadScreen.h.s"
.include "main.h.s"
.include "menu.h.s"
.include "player.h.s"
.include "map.h.s"
.include "gui.h.s"
.include "dobleBuffer.h.s"
.include "packs.h.s"

dead_state_game: .db #0
only_one2:.db #0
final_colours: .dw #0xFFFF

ds_DeadState:

    call ds_DrawThings

   ld hl, #Key_Return
   call key_isKeyPressed
   cp #0
   jr z, exit_ds              ;;if it is not pressed, continue in menu

        call ds_ResetVariables
        call buffer_clearFront
        call buffer_clearBack
        jp menu_init
        
   exit_ds:

ret

;;========================================================
;; menu_RESETVARIABLES: Reset all level variables
;;
;; DESTROYS:
;;        AF
;;========================================================   

ds_ResetVariables:

    ld a, #1
    ld (menu_state_game), a

    ld a, #0
    ld (dead_state_game), a

    ld  a, #1
    ld  (currentLevel), a

ret


ds_DrawThings:
    ;;Decompress deadscreen pack
    ld hl, #_deadScreen_pack_end
    ld de, #descompress_buffer_end
    call cpct_zx7b_decrunch_s_asm

    call buffer_getBack          ;; Charges into DE the back buffer memory pointer
    ld   c, #25              ;; C = Entity X
    ld   b, #42                 ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #gameOver
    ld   b, #8                ;; Height
    ld   c, #26                ;; Width
    call cpct_drawSprite_asm

    call buffer_getBack          ;; Charges into DE the back buffer memory pointer
    ld   c, #19              ;; C = Entity X
    ld   b, #117                 ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #bnwSprite
    ld   b, #8                ;; Height
    ld   c, #38                ;; Width
    call cpct_drawSprite_asm


    call buffer_getBack          ;; Charges into DE the back buffer memory pointer
    ld   c, #30             ;; C = Entity X
    ld   b, #67                 ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, (final_colours)
    ld   b, #32                ;; Height
    ld   c, #16              ;; Width
    call cpct_drawSprite_asm


    call buffer_getBack          ;; Charges into DE the back buffer memory pointer
    ld   c, #8              ;; C = Entity X
    ld   b, #150                  ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #pressRet 
    ld   b, #8                ;; Height
    ld   c, #63                 ;; Width
    call cpct_drawSprite_asm

   call buffer_switch

ret
