;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;; GLOBAL FUNCTIONS

;; == hero functions == ;;
;.globl hero_Die

;; == enemy functions == ;
.globl enemy_New
.globl enemy_Copy
.globl enemy_CopyDefault
.globl enemy_Destroy
.globl enemy_DoForAll
.globl enemy_Spawn
.globl enemy_Spawn2
.globl enemy2_Spawn2

.globl enemy_CreateNewEnemy
.globl enemy_Wait4Hero
.globl enemy_FollowHero
.globl enemy_CheckProximities
.globl check_entities_collision_x
.globl check_entities_collision_y
.globl enemy_GetEnemiesPtr
.globl enemy_GetEnemiesNumb
.globl enemy_GetEnemySize
.globl enemy_EveryEnemy
.globl enemy_DestroyEveryEnemy
.globl enemy_MoveScroll
.globl enemy_Hit
.globl enemy_DestroyAll


.globl enemy_vector
.globl enemy1_data
.globl enemy2_data

    
;; DEFINE ENEMY 
.macro DefineEnemy _name, _x, _y, _vx, _vy, _w, _h, _sprite, _frontX, _frontY, _backX, _backY, _upd, _dead, _bm, _health, _delay
_name: 
    DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sprite, _frontX, _frontY, _backX, _backY
   .db   _vx, _vy     ;; VX, VY
   .dw   _upd         ;; Update 
   .db   _dead          ;; Bloq Movement
   .db   _bm        ;; Dead
   .db   _health
   .db   _delay
_name'_size = . - _name
.endm

en_de       = 0
en_de_size  = 10                 ;;Size of the Drawable entity, by now we have to count the size of the DE
en_vx       = 0 + en_de_size     ;;New offsets 
en_vy       = 1 + en_de_size
en_up_l     = 2 + en_de_size
en_up_h     = 3 + en_de_size
en_dead     = 4 + en_de_size
en_bm       = 5 + en_de_size
en_health   = 6 + en_de_size
en_delay    = 7 + en_de_size


;;De esta forma tenemos los datos en un solo sitio
;;y cada vez que hagamos DefineEntityDefault nombre
;;se creara una entidad con estos valores.
;;El sufijo es para concatenarselo al nombre y que no sea duplicado
.macro DefineEnemyDefault _name, _suf                      
    DefineEnemy _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0xFFFF,0,0,0,0 0xFFFF, 1, 0, 0, 0
.endm

;;Con esta macro lo que estamos haciendo es crear tantas entidades como pongamos en N
;;Ademas de esto las entidades se guardan con el nombre+numero de un contador, para
;;que asi no de error de duplicado
.macro DefineNEnemy _name, _n
    _c = 0
    .rept _n
        DefineEnemyDefault _name, \_c
        _c = _c + 1
    .endm
.endm


;;==================BOUNDING BOX MACRO=======================
.macro DefineBoundingBox _name, _x, _y, _w, _h
    _name: 
        .db _x, _y
        .db _w, _h
    _name'_size = . - _name
.endm

bb_x = 0    
bb_y = 1
bb_w = 2    
bb_h = 3

