;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.include "entity.h.s"
.include "dobleBuffer.h.s"
.include "main.h.s"
.include "render.h.s"




;;=========================================================
;; ENT_CLEAR: Erase a entity
;; DESTROY: AF, BC, DE, HL
;; INPUT: IX -> Pointer to entity
;;=========================================================

;;ent_Clear:
;;
;;    ld  a, de_col(ix)
;;    ex af, af'
;;
;;    ld  de_col(ix), #0
;;
;;    call ent_Draw
;;    ex af, af'
;;    ld de_col(ix), a
;;
;;ret

;;=========================================================
;; ACTUALIZAR UNA ENTIDAD
;; REGISTROS DESTRUIDOS:
;; ENTRADA: IX -> Puntero a entidad
;;=========================================================

ent_Update:
   ld     h, e_up_h(ix)
   ld     l, e_up_l(ix)
   jp    (hl)


;;================================================
;; ENT_DRAW: Draw a entity
;; DESTROY: AF, AF', BC, DE, HL
;; INPUT: IX -> Pointer to entity
;;================================================

ent_Draw:
   jp ren_DrawEntity

;;========================================================
;; MOVER UNA ENTIDAD
;; REGISTROS DESTRUIDOS:
;; ENTRADA: IX -> Puntero a entidad
;;=======================================================

ent_Move:

   ld    a, de_x(ix) 
   add   e_vx(ix)
   ld    de_x(ix), a

   ld    a, de_y(ix) 
   add   e_vy(ix)
   ld    de_y(ix), a

ret
