;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;==GLOBAL FUNCTIONS==;;
.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_etm_drawTilemap4x8_ag_asm
.globl cpct_isKeyPressed_asm
.globl cpct_scanKeyboard_asm

.globl map_Update
.globl currentLevel
.globl scrolling
.globl m_next_element
.globl regionCounter
.globl scrollsCounter
.globl Level11

;;==============================================;;
;;                                              ;;
;;               ELEMENTS MACROS                ;;
;;                                              ;;
;;==============================================;;

;;=====================================================================
;;  DefineElement: creates in memory the data for 1 Element
;;  PARAMETERS: 
;;          Y    -> Y position of the Element (equivalent to Regions)
;;          TYPE -> Type of the Element to create
;;          X    -> X position of the Element (on the screen)
;;=====================================================================

.macro DefineElement _y, _type, _x
   .db _y, _type, _x
.endm


;;==========================================================================================
;;  DefineLevels: creates in memory the data for all the elements inside the LEVELS
;;
;;  PARAMETERS: 
;;          NAME -> Name for the list of Elements
;;==========================================================================================

.macro DefineLevel11 _name
_name:

DefineElement 6, 1, 16
DefineElement 6, 1, 64
DefineElement 12, 1, 16
DefineElement 12, 1, 64
DefineElement 19, 1, 16
DefineElement 19, 1, 40
DefineElement 19, 1, 64
DefineElement 26, 2, 48
DefineElement 37, 1, 16
DefineElement 37, 1, 64
DefineElement 44, 2, 16
DefineElement 44, 1, 64
DefineElement 45, 0, 20
DefineElement 52, 2, 16
DefineElement 52, 1, 64
DefineElement 53, 0, 20
DefineElement 60, 2, 16
DefineElement 60, 1, 64
DefineElement 61, 0, 20
DefineElement 68, 1, 40
DefineElement 69, 0, 70
DefineElement 75, 1, 40
DefineElement 77, 0, 20
DefineElement 83, 1, 40
DefineElement 85, 0, 58
DefineElement 91, 1, 40
DefineElement 92, 0, 34
DefineElement 92, 0, 60
DefineElement 99, 1, 40
DefineElement 100, 0, 20
DefineElement 101, 0, 72
DefineElement 107, 1, 40
DefineElement 108, 0, 34
DefineElement 108, 0, 60
DefineElement 113, 0, 56
DefineElement 116, 0, 20
DefineElement 116, 0, 72
DefineElement 119, 0, 40

;;=========Si quereis jugar el nivel entero, descomentais todas las lineas de arriba==========
;;=========y las dos de abajo de este comentario, la que está comentada la descomentais=======
;;=========y la que esta descomentada la comentais, un saludo=================================

DefineElement 119, 11, 0
;DefineElement 27, 11, 0

_name'_size = . - _name
.endm

;;==================TRANSITION L1.1 TO L1.2=============================
.macro DefineTransition1 _name
_name:

DefineElement 10, 51, 0

_name'_size = . - _name
.endm
;;======================================================================

.macro DefineLevel12 _name
_name:

DefineElement 13, 2, 32
DefineElement 16, 0, 72
DefineElement 16, 25, 0
DefineElement 18, 2, 16
DefineElement 21, 0, 22
DefineElement 23, 2, 32
DefineElement 25, 0, 66
DefineElement 28, 0, 20
DefineElement 28, 2, 48
DefineElement 35, 0, 32
DefineElement 35, 1, 16
DefineElement 35, 1, 64
DefineElement 38, 0, 44
DefineElement 41, 1, 16
DefineElement 41, 0, 44
DefineElement 41, 1, 64
DefineElement 47, 0, 16
DefineElement 49, 0, 62
DefineElement 50, 0, 32
DefineElement 52, 2, 36
DefineElement 54, 0, 64
DefineElement 55, 0, 16
DefineElement 56, 3, 38
DefineElement 57, 0, 46
DefineElement 60, 2, 26
DefineElement 61, 0, 70
DefineElement 62, 0, 24
DefineElement 64, 0, 50
DefineElement 67, 3, 16
DefineElement 67, 1, 64
DefineElement 73, 1, 22
DefineElement 73, 0, 54
DefineElement 77, 1, 60
DefineElement 79, 0, 30
DefineElement 82, 2, 32
DefineElement 84, 0, 26
DefineElement 86, 2, 16
DefineElement 91, 2, 48
DefineElement 92, 3, 16
DefineElement 92, 0, 34
DefineElement 92, 0, 68
DefineElement 98, 1, 24
DefineElement 98, 0, 44
DefineElement 98, 50, 0
DefineElement 103, 2, 30
DefineElement 107, 0, 30
DefineElement 108, 1, 62
DefineElement 112, 2, 18
DefineElement 114, 0, 20
DefineElement 116, 2, 46
DefineElement 118, 0, 38
DefineElement 120, 2, 18
DefineElement 122, 0, 20
DefineElement 124, 3, 18
DefineElement 124, 0, 56
DefineElement 126, 2, 46
DefineElement 131, 3, 28
DefineElement 131, 0, 44
DefineElement 133, 3, 60
DefineElement 135, 0, 22
DefineElement 135, 0, 52
DefineElement 138, 1, 28
DefineElement 138, 1, 56
DefineElement 140, 0, 68
DefineElement 141, 0, 24
DefineElement 144, 2, 32
DefineElement 147, 0, 26
DefineElement 149, 0, 46
DefineElement 151, 3, 56
DefineElement 156, 2, 32
DefineElement 157, 0, 38
DefineElement 160, 0, 62
DefineElement 163, 0, 28
DefineElement 163, 1, 58
DefineElement 166, 0, 62
DefineElement 168, 1, 18
DefineElement 173, 2, 16
DefineElement 175, 0, 24
DefineElement 178, 2, 16
DefineElement 180, 0, 22
DefineElement 180, 3, 72
DefineElement 183, 2, 16
DefineElement 185, 0, 66
DefineElement 188, 2, 48
DefineElement 188, 75, 0
DefineElement 190, 3, 22
DefineElement 190, 0, 44
DefineElement 193, 2, 48
DefineElement 195, 0, 30
DefineElement 198, 1, 16
DefineElement 198, 2, 48
DefineElement 199, 0, 70
DefineElement 200, 0, 22
DefineElement 205, 1, 16
DefineElement 205, 1, 64
DefineElement 207, 0, 22
DefineElement 209, 3, 44
DefineElement 213, 1, 16
DefineElement 213, 1, 64
DefineElement 215, 0, 60
DefineElement 217, 3, 44
DefineElement 219, 0, 26
DefineElement 219, 0, 60
DefineElement 221, 1, 16
DefineElement 221, 1, 64
DefineElement 226, 1, 16
DefineElement 226, 1, 64
DefineElement 231, 2, 32
DefineElement 232, 0, 72
DefineElement 234, 0, 30
DefineElement 237, 1, 16
DefineElement 237, 1, 64
DefineElement 241, 0, 40
DefineElement 243, 1, 16
DefineElement 243, 1, 40
DefineElement 243, 1, 64
DefineElement 245, 0, 46
DefineElement 247, 0, 64
DefineElement 248, 0, 26
DefineElement 250, 2, 26
DefineElement 250, 0, 68
DefineElement 252, 0, 30
DefineElement 254, 0, 66
DefineElement 255, 0, 24

;;=========Si quereis jugar el nivel entero, descomentais todas las lineas de arriba==========
;;=========y las dos de abajo de este comentario, la que está comentada la descomentais=======
;;=========y la que esta descomentada la comentais, un saludo=================================

DefineElement 255, 12, 0
;DefineElement 40, 12, 0

_name'_size = . - _name
.endm

;;==================TRANSITION L1.2 TO L2.1=============================
.macro DefineTransition2 _name
_name:

DefineElement 10, 52, 0

_name'_size = . - _name
.endm
;;======================================================================


.macro DefineLevel21 _name
_name:

DefineElement 13, 6, 48
DefineElement 19, 0, 24
DefineElement 23, 1, 42
DefineElement 25, 0, 64
DefineElement 28, 0, 26
DefineElement 32, 2, 34
DefineElement 34, 0, 24
DefineElement 34, 0, 70
DefineElement 39, 1, 16
DefineElement 40, 5, 20
DefineElement 44, 1, 64
DefineElement 45, 5, 72
DefineElement 49, 2, 16
DefineElement 50, 5, 22
DefineElement 54, 2, 48
DefineElement 55, 5, 70
DefineElement 59, 6, 48
DefineElement 60, 3, 16
DefineElement 60, 3, 36
DefineElement 60, 3, 54
DefineElement 60, 3, 72
DefineElement 63, 5, 18
DefineElement 66, 3, 16
DefineElement 66, 3, 72
DefineElement 69, 1, 42
DefineElement 71, 0, 24
DefineElement 74, 0, 68
DefineElement 79, 2, 34
DefineElement 85, 2, 16
DefineElement 86, 5, 28
DefineElement 92, 2, 48
DefineElement 93, 5, 62
DefineElement 97, 6, 48
DefineElement 98, 1, 16
DefineElement 98, 1, 64
DefineElement 99, 5, 24
DefineElement 103, 1, 16
DefineElement 103, 1, 64
DefineElement 104, 5, 68
DefineElement 108, 1, 16
DefineElement 108, 1, 64
DefineElement 108, 25, 0
DefineElement 109, 5, 24
DefineElement 114, 2, 34
DefineElement 115, 6, 50
DefineElement 117, 2, 34

;;=========Si quereis jugar el nivel entero, descomentais todas las lineas de arriba==========
;;=========y las dos de abajo de este comentario, la que está comentada la descomentais=======
;;=========y la que esta descomentada la comentais, un saludo=================================

DefineElement 119, 21, 0
;DefineElement 40, 21, 0

_name'_size = . - _name
.endm

;;==================TRANSITION L2.1 TO L2.2=============================
.macro DefineTransition3 _name
_name:

DefineElement 10, 53, 0

_name'_size = . - _name
.endm
;;======================================================================

.macro DefineLevel22 _name
_name:

DefineElement 13, 2, 16
DefineElement 17, 0, 34
DefineElement 17, 3, 56
DefineElement 22, 3, 32
DefineElement 22, 0, 58
DefineElement 27, 0, 34
DefineElement 27, 3, 56
DefineElement 32, 3, 32
DefineElement 32, 0, 58
DefineElement 35, 5, 16
DefineElement 35, 5, 76
DefineElement 39, 5, 16
DefineElement 39, 5, 76
DefineElement 41, 1, 16
DefineElement 41, 1, 64
DefineElement 42, 5, 22
DefineElement 47, 1, 16
DefineElement 47, 1, 64
DefineElement 48, 5, 70
DefineElement 52, 2, 24
DefineElement 56, 0, 64
DefineElement 59, 0, 28
DefineElement 61, 2, 40
DefineElement 66, 0, 30
DefineElement 70, 0, 62
DefineElement 73, 2, 32
DefineElement 76, 0, 46
DefineElement 80, 5, 16
DefineElement 84, 0, 38
DefineElement 88, 2, 28
DefineElement 93, 3, 26
DefineElement 94, 5, 28
DefineElement 97, 0, 28
DefineElement 97, 3, 56
DefineElement 98, 5, 58
DefineElement 98, 50, 0
DefineElement 102, 1, 30
DefineElement 103, 5, 34
DefineElement 107, 0, 36
DefineElement 107, 3, 58
DefineElement 108, 5, 60
DefineElement 113, 3, 30
DefineElement 113, 1, 58
DefineElement 114, 5, 32
DefineElement 118, 0, 66
DefineElement 121, 0, 28
DefineElement 124, 2, 16
DefineElement 125, 5, 20
DefineElement 128, 0, 46
DefineElement 130, 2, 48
DefineElement 131, 5, 72
DefineElement 134, 0, 34
DefineElement 136, 2, 16
DefineElement 137, 5, 20
DefineElement 140, 0, 56
DefineElement 142, 2, 48
DefineElement 143, 5, 72
DefineElement 146, 0, 36
DefineElement 152, 1, 16
DefineElement 152, 0, 46
DefineElement 152, 1, 64
DefineElement 155, 5, 16
DefineElement 158, 1, 16
DefineElement 158, 0, 56
DefineElement 158, 1, 64
DefineElement 161, 5, 76
DefineElement 164, 1, 16
DefineElement 164, 0, 36
DefineElement 164, 1, 64
DefineElement 167, 5, 16
DefineElement 170, 1, 16
DefineElement 170, 0, 52
DefineElement 170, 1, 64
DefineElement 176, 3, 36
DefineElement 180, 0, 28
DefineElement 180, 75, 0
DefineElement 180, 1, 52
DefineElement 185, 0, 26
DefineElement 185, 3, 56
DefineElement 186, 5, 76
DefineElement 191, 1, 30
DefineElement 191, 0, 64
DefineElement 192, 5, 16
DefineElement 197, 3, 16
DefineElement 197, 2, 48
DefineElement 198, 5, 16
DefineElement 202, 3, 28
DefineElement 203, 2, 48
DefineElement 205, 5, 74
DefineElement 207, 5, 74
DefineElement 209, 2, 48
DefineElement 210, 1, 24
DefineElement 211, 0, 66
DefineElement 213, 0, 26
DefineElement 215, 3, 16
DefineElement 215, 2, 48
DefineElement 216, 5, 16
DefineElement 222, 1, 16
DefineElement 222, 5, 32
DefineElement 222, 1, 64
DefineElement 228, 1, 16
DefineElement 228, 5, 60
DefineElement 228, 1, 64
DefineElement 231, 0, 46
DefineElement 234, 3, 16
DefineElement 234, 1, 40
DefineElement 234, 3, 64
DefineElement 235, 5, 16
DefineElement 235, 5, 76
DefineElement 240, 1, 16
DefineElement 240, 1, 64
DefineElement 241, 5, 16
DefineElement 241, 5, 76
DefineElement 246, 2, 16
DefineElement 247, 5, 16
DefineElement 249, 2, 48
DefineElement 250, 5, 76
DefineElement 252, 0, 24
DefineElement 253, 5, 16
DefineElement 254, 0, 66
DefineElement 255, 5, 76

;;=========Si quereis jugar el nivel entero, descomentais todas las lineas de arriba==========
;;=========y las dos de abajo de este comentario, la que está comentada la descomentais=======
;;=========y la que esta descomentada la comentais, un saludo=================================

DefineElement 255, 22, 0
;DefineElement 40, 22, 0

_name'_size = . - _name
.endm

;;==================TRANSITION L2.2 TO L3.1=============================
.macro DefineTransition4 _name
_name:

DefineElement 10, 54, 0

_name'_size = . - _name
.endm
;;======================================================================

.macro DefineLevel31 _name
_name:

DefineElement 14, 2, 16
DefineElement 18, 3, 28
DefineElement 19, 2, 48
DefineElement 26, 4, 40
DefineElement 32, 2, 16
DefineElement 33, 3, 62
DefineElement 37, 2, 48
DefineElement 42, 4, 22
DefineElement 47, 4, 56
DefineElement 52, 1, 18
DefineElement 52, 1, 62
DefineElement 56, 1, 42
DefineElement 59, 0, 58
DefineElement 62, 4, 24
DefineElement 67, 3, 24
DefineElement 67, 3, 44
DefineElement 67, 3, 64
DefineElement 68, 5, 24
DefineElement 68, 5, 68
DefineElement 74, 2, 32
DefineElement 76, 0, 28
DefineElement 79, 0, 68
DefineElement 84, 4, 26
DefineElement 89, 4, 58
DefineElement 94, 4, 36
DefineElement 99, 6, 48
DefineElement 102, 1, 16
DefineElement 102, 1, 64
DefineElement 103, 5, 18
DefineElement 107, 4, 38
DefineElement 110, 1, 16
DefineElement 110, 1, 64
DefineElement 111, 5, 20
DefineElement 115, 4, 28
DefineElement 119, 4, 48

;;=========Si quereis jugar el nivel entero, descomentais todas las lineas de arriba==========
;;=========y las dos de abajo de este comentario, la que está comentada la descomentais=======
;;=========y la que esta descomentada la comentais, un saludo=================================

DefineElement 119, 31, 0
;DefineElement 15, 31, 0

_name'_size = . - _name
.endm

;;==================TRANSITION L3.1 TO L3.2=============================
.macro DefineTransition5 _name
_name:

DefineElement 10, 55, 0

_name'_size = . - _name
.endm
;;======================================================================

.macro DefineLevel32 _name
_name:

DefineElement 13, 1, 16
DefineElement 14, 5, 18
DefineElement 17, 1, 56
DefineElement 18, 0, 62
DefineElement 22, 3, 28
DefineElement 22, 5, 76
DefineElement 24, 0, 26
DefineElement 27, 1, 30
DefineElement 27, 25, 0
DefineElement 30, 0, 62
DefineElement 33, 0, 26
DefineElement 38, 2, 32
DefineElement 40, 0, 28
DefineElement 43, 2, 48
DefineElement 44, 3, 16
DefineElement 45, 5, 16
DefineElement 48, 2, 16
DefineElement 49, 5, 42
DefineElement 54, 4, 18
DefineElement 56, 0, 60
DefineElement 58, 0, 22
DefineElement 58, 3, 72
DefineElement 62, 4, 58
DefineElement 66, 3, 16
DefineElement 67, 5, 16
DefineElement 71, 4, 32
DefineElement 76, 1, 16
DefineElement 76, 5, 56
DefineElement 76, 1, 64
DefineElement 77, 5, 18
DefineElement 81, 1, 16
DefineElement 81, 1, 42
DefineElement 82, 5, 22
DefineElement 86, 1, 40
DefineElement 86, 1, 64
DefineElement 87, 5, 70
DefineElement 93, 2, 16
DefineElement 97, 4, 20
DefineElement 101, 2, 48
DefineElement 105, 4, 42
DefineElement 109, 2, 16
DefineElement 110, 5, 28
DefineElement 113, 4, 38
DefineElement 117, 2, 48
DefineElement 118, 5, 64
DefineElement 122, 0, 24
DefineElement 122, 3, 42
DefineElement 125, 0, 64
DefineElement 127, 3, 16
DefineElement 127, 0, 44
DefineElement 131, 0, 22
DefineElement 131, 50, 0
DefineElement 133, 1, 30
DefineElement 133, 0, 64
DefineElement 135, 0, 24
DefineElement 138, 1, 64
DefineElement 143, 2, 16
DefineElement 144, 5, 20
DefineElement 148, 4, 38
DefineElement 150, 2, 34
DefineElement 154, 4, 40
DefineElement 156, 0, 30
DefineElement 159, 3, 16
DefineElement 160, 5, 18
DefineElement 164, 3, 72
DefineElement 165, 5, 74
DefineElement 169, 1, 16
DefineElement 170, 5, 26
DefineElement 174, 1, 64
DefineElement 175, 5, 66
DefineElement 179, 2, 16
DefineElement 180, 5, 36
DefineElement 184, 2, 48
DefineElement 185, 5, 58
DefineElement 191, 0, 18
DefineElement 191, 2, 32
DefineElement 191, 0, 70
DefineElement 197, 4, 32
DefineElement 202, 0, 20
DefineElement 202, 2, 32
DefineElement 202, 0, 72
DefineElement 205, 0, 32
DefineElement 208, 4, 54
DefineElement 213, 1, 16
DefineElement 213, 3, 44
DefineElement 214, 5, 26
DefineElement 217, 1, 64
DefineElement 218, 5, 66
DefineElement 221, 1, 16
DefineElement 222, 5, 26
DefineElement 225, 3, 44
DefineElement 225, 75, 0
DefineElement 225, 1, 64
DefineElement 226, 5, 66
DefineElement 230, 4, 32
DefineElement 234, 3, 18
DefineElement 235, 5, 20
DefineElement 238, 4, 56
DefineElement 244, 1, 16
DefineElement 244, 3, 70
DefineElement 245, 5, 22
DefineElement 245, 5, 72
DefineElement 252, 4, 54
DefineElement 255, 4, 28


;;=========Si quereis jugar el nivel entero, descomentais todas las lineas de arriba==========
;;=========y las dos de abajo de este comentario, la que está comentada la descomentais=======
;;=========y la que esta descomentada la comentais, un saludo=================================

DefineElement 255, 32, 0
;DefineElement 15, 32, 0

_name'_size = . - _name
.endm

;;==================TRANSITION L3.2 TO LFinal=============================
.macro DefineTransition6 _name
_name:

DefineElement 10, 56, 0

_name'_size = . - _name
.endm
;;======================================================================

.macro DefineLevel41 _name
_name:
DefineElement 13, 2, 24
DefineElement 15, 0, 48
DefineElement 19, 4, 40
DefineElement 23, 3, 16
DefineElement 24, 5, 18
DefineElement 29, 4, 30
DefineElement 33, 3, 72
DefineElement 34, 5, 74
DefineElement 39, 4, 46
DefineElement 44, 2, 34
DefineElement 46, 0, 26
DefineElement 48, 0, 64
DefineElement 51, 1, 28
DefineElement 55, 0, 30
DefineElement 55, 3, 48
DefineElement 59, 1, 16
DefineElement 60, 5, 18
DefineElement 63, 0, 42
DefineElement 63, 3, 72
DefineElement 64, 5, 74
DefineElement 68, 1, 34
DefineElement 68, 0, 64
DefineElement 73, 4, 42
DefineElement 78, 2, 32
DefineElement 80, 0, 28
DefineElement 83, 2, 16
DefineElement 84, 3, 72
DefineElement 85, 5, 76
DefineElement 88, 2, 48
DefineElement 89, 5, 42
DefineElement 94, 4, 18
DefineElement 100, 3, 16
DefineElement 100, 0, 46
DefineElement 100, 3, 72
DefineElement 103, 5, 16
DefineElement 106, 3, 16
DefineElement 106, 0, 56
DefineElement 106, 3, 72
DefineElement 109, 5, 76
DefineElement 112, 3, 16
DefineElement 112, 0, 36
DefineElement 112, 3, 72
DefineElement 118, 5, 52
DefineElement 118, 1, 56
DefineElement 124, 4, 40
DefineElement 129, 1, 24
DefineElement 129, 5, 40
DefineElement 135, 4, 42
DefineElement 140, 2, 16
DefineElement 141, 5, 26
DefineElement 144, 0, 42
DefineElement 146, 2, 48
DefineElement 147, 5, 66
DefineElement 150, 0, 32
DefineElement 155, 0, 24
DefineElement 155, 3, 44
DefineElement 155, 0, 68
DefineElement 160, 3, 16
DefineElement 160, 3, 72
DefineElement 161, 5, 18
DefineElement 161, 5, 74
DefineElement 165, 0, 26
DefineElement 165, 3, 44
DefineElement 165, 0, 68
DefineElement 170, 3, 16
DefineElement 170, 3, 72
DefineElement 171, 5, 18
DefineElement 171, 5, 74
DefineElement 175, 0, 24
DefineElement 175, 1, 40
DefineElement 175, 0, 68
DefineElement 180, 4, 26
DefineElement 183, 4, 58
DefineElement 188, 2, 16
DefineElement 189, 5, 22
DefineElement 191, 0, 32
DefineElement 191, 3, 64
DefineElement 193, 1, 16
DefineElement 193, 0, 62
DefineElement 194, 5, 22
DefineElement 197, 2, 36
DefineElement 198, 5, 62
DefineElement 200, 0, 34
DefineElement 203, 1, 64
DefineElement 204, 5, 70
DefineElement 208, 3, 40
DefineElement 208, 0, 64
DefineElement 209, 5, 44
DefineElement 212, 2, 26
DefineElement 214, 0, 36
DefineElement 218, 1, 16
DefineElement 218, 0, 46
DefineElement 218, 1, 64
DefineElement 219, 5, 74
DefineElement 224, 4, 26
DefineElement 227, 4, 58
DefineElement 230, 4, 26
DefineElement 233, 4, 58
DefineElement 238, 2, 32
DefineElement 239, 0, 68
DefineElement 241, 0, 24
DefineElement 243, 3, 16
DefineElement 243, 3, 72
DefineElement 244, 5, 18
DefineElement 244, 5, 74
DefineElement 247, 4, 40
DefineElement 249, 0, 46
DefineElement 251, 3, 16
DefineElement 251, 3, 72
DefineElement 252, 5, 18
DefineElement 252, 5, 74
DefineElement 253, 0, 70
DefineElement 255, 4, 38
DefineElement 255, 41, 0

_name'_size = . - _name
.endm

;;==================TRANSITION LFinal TO WIN=============================
.macro DefineTransition7 _name
_name:

DefineElement 10, 57, 0

_name'_size = . - _name
.endm
;;======================================================================



