;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;; Include all CPCtelera constant definitions, macros and variables
.include "enemy.h.s"
.include "main.h.s"
.include "player.h.s"
.include "menu.h.s"
.include "dobleBuffer.h.s"
.include "deadScreen.h.s"
.include "gui.h.s"

menu_state_game: .db #0
only_one: .db #0

menu_StartGame:

   ld   a, (only_one)
   inc  a
   ld   (only_one), a
   cp   #1
   jr   z, here
    
    call menu_DrawScreen

   here:
   ld hl, #Key_P
   call key_isKeyPressed
   cp #0
   jr z, exit_menu               ;;if it is not pressed, continue in menu

        call buffer_clearBack
         call buffer_clearFront

        call gui_DrawLevel
        call gui_InitColours

        ld  hl, #_colours_0
        ld  (final_colours), hl

        ld a, #1
        ld (menu_state_game), a

        jp init_game    
        
   exit_menu:

ret


menu_DrawScreen:

   ;;call buffer_getBack          ;; Charges into DE the back buffer memory pointer
   ;;ld   c, #8                   ;; C = Entity X
   ;;ld   b, #0                  ;; B = Entity Y
   ;;call cpct_getScreenPtr_asm
;;
   ;;ex   de, hl
   ;;ld   hl, #_menu_logo1
   ;;ld   b, #64                  ;; Height
   ;;ld   c, #32                  ;; Width
   ;;call cpct_drawSprite_asm
;;
   ;;call buffer_getBack          ;; Charges into DE the back buffer memory pointer
   ;;ld   c, #40                  ;; C = Entity X
   ;;ld   b, #0                ;; B = Entity Y
   ;;call cpct_getScreenPtr_asm
;;
   ;;ex   de, hl
   ;;ld   hl, #_menu_logo2
   ;;ld   b, #64                  ;; Height
   ;;ld   c, #32                  ;; Width
   ;;call cpct_drawSprite_asm

   call buffer_getBack          ;; Charges into DE the back buffer memory pointer
   ld   c, #16                 ;; C = Entity X
   ld   b, #168                ;; B = Entity Y
   call cpct_getScreenPtr_asm

   ex   de, hl
   ld   hl, #_menu_pressToPlay
   ld   b, #8                  ;; Height
   ld   c, #43                ;; Width
   call cpct_drawSprite_asm

   call buffer_getFront        ;; Charges into DE the back buffer memory pointer
   ld   c, #16                 ;; C = Entity X
   ld   b, #168                 ;; B = Entity Y
   call cpct_getScreenPtr_asm

   ex   de, hl
   ld   hl, #_menu_pressToPlay
   ld   b, #8                  ;; Height
   ld   c, #43                ;; Width
   call cpct_drawSprite_asm


ret