;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.globl obstacle_New
.globl obstacle_Copy
.globl obstacle_CopyDefault
.globl obstacle_DoForAll
.globl obstacle_Spawn
.globl obstacle_Spawn2

.globl obstacle_EveryObstacle
.globl obstacle_Collisions
.globl obstacle_BulletCollisions
.globl obstacle_BoundingBoxCollisions
.globl obstacle_DestroyEveryObstacle 


.globl obstacle_data
.globl obstacle2_data
.globl obstacle3_data
.globl obstacle4_data
.globl obstacle5_data

;;=== Scroll ===
.globl obstacle_MoveScroll
.globl obstacle_GetNumObstacle
.globl obstacle_setPosition


.macro DefineObstacle _name, _x, _y, _vx, _vy, _w, _h, _sprite, _frontX, _frontY, _backX, _backY, _upd, _dead, _kill, _clockAnimation, _typeAnimation
_name: 
    DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sprite, _frontX, _frontY, _backX, _backY
   .db   _vx, _vy     ;; VX, VY
   .dw   _upd        ;; Update
   .db   _dead       ;;Dead 
   .db   _kill       ;;If the obstacle can kill the player   
   .db   _clockAnimation
   .db   _typeAnimation
_name'_size = . - _name
.endm

.macro DefineObstacleDefault _name, _suf                      
    DefineObstacle _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0xFFFF,0,0,0,0 0xFFFF, 1, 0, -1, -1
.endm

.macro DefineNObstacles _name, _n
    _c = 0
    .rept _n
        DefineObstacleDefault _name, \_c
        _c = _c + 1
    .endm
.endm

o_de               = 0
o_de_size          = 10                 ;;Size of the Drawable entity, by now we have to count the size of the DE
o_vx               = 0 + o_de_size     ;;New offsets 
o_vy               = 1 + o_de_size
o_up_l             = 2 + o_de_size
o_up_h             = 3 + o_de_size
o_dead             = 4 + o_de_size
o_kill             = 5 + o_de_size
o_clockAnimation   = 6 + o_de_size
o_typeAnimation    = 7 + o_de_size