;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.globl pu_New
.globl pu_Copy
.globl pu_DoForAll
.globl pu_DestroyAllPU
.globl pu_MoveScroll
.globl pu_GetPUSize
.globl pu_TryToSpawnPU
.globl pu_Spawn

.globl pu_data
.globl level2




.macro DefinePU _name, _x, _y, _vx, _vy, _w, _h, _sprite, _frontX, _frontY, _backX, _backY, _upd, _lft, _dead
_name: 
    DefineDrawableEntity _name'_dw, _x, _y, _w, _h, _sprite, _frontX, _frontY, _backX, _backY
   .db   _vx, _vy    ;; VX, VY
   .dw   _upd        ;; Update 
   .db   _lft        ;; Lifetime
   .db   _dead       ;; Dead
_name'_size = . - _name
.endm

.macro DefinePUDefault _name, _suf                      
    DefinePU _name'_suf, 0xAA, 0, 0, 0, 0, 0, 0xFFFF, 0,0,0,0, 0xFFFF, 0, 1
.endm

.macro DefineNPU _name, _n
    _c = 0
    .rept _n
        DefinePUDefault _name, \_c
        _c = _c + 1
    .endm
.endm

pu_de       = 0
pu_de_size  = 10                 ;;Size of the Drawable entity, by now we have to count the size of the DE
pu_vx       = 0 + pu_de_size    ;;New offsets 
pu_vy       = 1 + pu_de_size
pu_up_l     = 2 + pu_de_size
pu_up_h     = 3 + pu_de_size
pu_lft      = 4 + pu_de_size
pu_dead     = 5 + pu_de_size
