;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.include "randomManager.h.s"
.include "main.h.s"
.include "render.h.s"

;;====================================================================================================
;; random_GETRANDOMSCREENPOSITION: Generate a X random position to spawn an entity by a given width
;; INPUTS:
;;       D -> Entity width
;;       L -> Entropy byte to mix the sequence
;; OUTPUT: 
;;       A -> X position
;; DESTROYS: 
;;      AF, BC, HL, IX 
;;====================================================================================================

random_GetRandomScreenPosition:

    call cpct_getRandom_lcg_u8_asm

    ld  a, l
    ld  b, #80

    push af

    ld a, b
    sub d               ;;Entity's width
    ld  b, a

    pop af

    and b
    cp #0
    ret z

ret

;;====================================================================================================
;; random_GETRANDOMNUMBER: Generate a random number with a given mask to mix the random sequence
;;       B -> Mask to apply to the random number
;; OUTPUT: 
;;       A -> Random number
;; DESTROYS: 
;;      AF, BC, HL, IX 
;;====================================================================================================

random_GetRandomNumber:

	call	cpct_getRandom_lcg_u8_asm		
	ld		a,	l												
	and		b	                            							
    ;;A = Random number at this point

ret