;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.globl ren_DrawEntity
.globl ren_Clear
.globl ren_Clear_FrontBack
.globl ren_Clear_Front_Enemies

;;
;;====SPRITES===
;;

;;Player frame 1
.globl _playerLeft_0
.globl _playerRight_0
.globl _playerDown_0
.globl _playerUpRight_0
.globl _playerUpLeft_0
.globl _playerDownLeft_0
.globl _playerDownRight_0
.globl _playerUp_0

;;Player frame 2
.globl _playerLeft_1
.globl _playerRight_1
.globl _playerDown_1
.globl _playerUpRight_1
.globl _playerUpLeft_1
.globl _playerDownLeft_1
.globl _playerDownRight_1
.globl _playerUp_1

;;Power UP
.globl _pu_sprite

;;Assasin obstacle
.globl _assassinObstacle_0
.globl _assassinObstacle_1

;;Bullets
.globl _bulletSprite
.globl _laserSprite


.macro DefineDrawableEntity _name, _x, _y, _w, _h, _sprite, _frontX, _frontY, _backX, _backY
    _name: 
        .db _x, _y
        .db _w, _h
        .dw _sprite

        ;;To erase the buffer
        .db _frontX
        .db _frontY
        .db _backX
        .db _backY
    _name'_size = . - _name
.endm

de_x = 0    
de_y = 1
de_w = 2    
de_h = 3
de_sprite_l = 4
de_sprite_h = 5
de_frontX = 6
de_frontY = 7
de_backX  = 8
de_backY  = 9