;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.include "render.h.s"
.include "main.h.s"
.include "dobleBuffer.h.s"


ren_DrawEntity:

   call buffer_getBack               ;; Charges into DE the back buffer memory pointer
   ld     c, de_x(ix)                ;; C = Entity X
   ld     b, de_y(ix)                ;; B = Entity Y
   call cpct_getScreenPtr_asm

   ex    de, hl                      ;; DE = Pointer to memory
   ld l, de_sprite_l(ix)
   ld h, de_sprite_h(ix)
   ld  b, de_h(ix)                        ;; Height
   ld  c, de_w(ix)                         ;; Width
   call cpct_drawSprite_asm

   call ren_SaveCoordinates

ret

ren_Clear:
    call buffer_getBack               ;; Charges into DE the back buffer memory pointer

    call ren_GetCoordinates          ;;Return in B->Y, C->X
    ld a, c
    cp #16
    jp m, exit
        call cpct_getScreenPtr_asm

        ex de, hl
        ld a, #0x00
        ld  b, de_h(ix)                        ;; Height
        ld  c, de_w(ix)                        ;; Width


        call cpct_drawSolidBox_asm
    exit:
ret


ren_Clear_FrontBack:
    call buffer_getFront               ;; Charges into DE the back buffer memory pointer

    ld b, de_frontY(ix)
    ld c, de_frontX(ix)
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld  b, de_h(ix)                        ;; Height
    ld  c, de_w(ix)                        ;; Width

    call cpct_drawSolidBox_asm

    call buffer_getFront               ;; Charges into DE the back buffer memory pointer

    ld b, de_backY(ix)
    ld c, de_backX(ix)
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld  b, de_h(ix)                        ;; Height
    ld  c, de_w(ix)                        ;; Width

    call cpct_drawSolidBox_asm
ret

ren_Clear_Front_Enemies:
    call buffer_getFront               ;; Charges into DE the back buffer memory pointer

    ld b, de_frontY(iy)
    ld c, de_frontX(iy)
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld  b, de_h(iy)                        ;; Height
    ld  c, de_w(iy)                        ;; Width

    call cpct_drawSolidBox_asm

    call buffer_getFront               ;; Charges into DE the back buffer memory pointer

    ld b, de_backY(iy)
    ld c, de_backX(iy)
    call cpct_getScreenPtr_asm

    ex de, hl
    ld a, #0x00
    ld  b, de_h(iy)                        ;; Height
    ld  c, de_w(iy)                        ;; Width
    
    call cpct_drawSolidBox_asm
ret


ren_SaveCoordinates:
    

    call buffer_getBack
    ld a, d
    cp #0xC0                     ;;Si es el front buffer, nos guardamos la posicion en la que pintamos en la variable de la macro
    jr nz, saveBack              ;;Si no, lo guardamos en la del back

    ld a, de_x(ix)
    ld de_frontX(ix), a
    ld a, de_y(ix)
    ld de_frontY(ix), a

    ret

    saveBack:

    ld a, de_x(ix)
    ld de_backX(ix), a
    ld a, de_y(ix)
    ld de_backY(ix), a

ret

ren_GetCoordinates:

    call buffer_getBack
    ld a, d
    cp #0xC0
    jr nz, getBack

    ld b, de_frontY(ix)
    ld c, de_frontX(ix)

    ret

    getBack:

    ld b, de_backY(ix)
    ld c, de_backX(ix)

ret