;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of BringRGBack: An Amstrad CPC Game 
;;  Copyright (C) 2018 Ivan Palacios Verano / Edward Thomas Owen Nolla / Javier Richarte Gras
;;
;;  BringRGBack is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  BringRGBack is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with BringRGBack.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Include all CPCtelera constant definitions, macros and variables
.include "enemy.h.s"
.include "main.h.s"
.include "player.h.s"
.include "winner.h.s"
.include "menu.h.s"
.include "deadScreen.h.s"
.include "dobleBuffer.h.s"
.include "gui.h.s"
.include "map.h.s"
.include "packs.h.s"

winner_win_state: .db #0
only_one: .db #0

winner_WinState:

   ld   a, (only_one)
   inc  a
   ld   (only_one), a
   cp   #1
   jr   z, here
    
    call winner_DrawThings

   here:
   ld hl, #Key_Return
   call key_isKeyPressed
   cp #0
   jr z, exit_win              ;;if it is not pressed, continue in menu

        call winner_ResetVariables
        call buffer_clearFront
        call buffer_clearBack
        jp init_game    
        
   exit_win:

ret


winner_DrawThings:

    ;;Decompress deadscreen pack
    ld hl, #_winScreen_pack_end 
    ld de, #descompress_buffer_end
    call cpct_zx7b_decrunch_s_asm

    call buffer_getBack          ;; Charges into DE the back buffer memory pointer
    ld   c, #28                  ;; C = Entity X
    ld   b, #42                  ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #winer
    ld   b, #8                    ;; Height
    ld   c, #20                   ;; Width
    call cpct_drawSprite_asm

    call buffer_getBack           ;; Charges into DE the back buffer memory pointer
    ld   c, #30                   ;; C = Entity X
    ld   b, #67                   ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #level_colours
    ld   b, #32                  ;; Height
    ld   c, #16                  ;; Width
    call cpct_drawSprite_asm

    call buffer_getBack          ;; Charges into DE the back buffer memory pointer
    ld   c, #18                  ;; C = Entity X
    ld   b, #116                 ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #recovered 
    ld   b, #8                   ;; Height
    ld   c, #41                  ;; Width
    call cpct_drawSprite_asm

    call buffer_getBack           ;; Charges into DE the back buffer memory pointer
    ld   c, #8                    ;; C = Entity X
    ld   b, #150                  ;; B = Entity Y
    call cpct_getScreenPtr_asm

    ex   de, hl
    ld   hl, #pressRet2 
    ld   b, #8                ;; Height
    ld   c, #63                 ;; Width
    call cpct_drawSprite_asm

    call buffer_switch

ret 


winner_ResetVariables:


    ld a, #0
    ld (menu_state_game), a

    ld a, #0
    ld (dead_state_game), a

    ld  a, #0
    ld (winner_win_state), a

    ld  a, #1
    ld  (currentLevel), a

ret